
#include <stdio.h>

#include "libr263.h"
#include "rlib.h"

#ifndef FALSE
#define FALSE 0
#endif
#ifndef TRUE
#define TRUE 1
#endif

FILE *outputstream; /* Must be declared global for OwnWriteFunction */

void OwnWriteFunction(int byte)
{
  putc(byte, outputstream);

  return;
}

int EncodeBlocks[9][11]; 
                                
int main()
{
  CParam cparams;
  Bits bits;
  FILE  *inputstream;
  FILE  *reconfile;
  struct qcif qcif_frame;
  int framecount;

  framecount = 0;

  /* Open input and output files */

  reconfile = fopen("recon.qcif","wb");
  outputstream = fopen("output.263","wb");
  inputstream = fopen("input.qcif","rb");

  if(!inputstream || !outputstream || !reconfile) {
    if(outputstream)
      fclose(outputstream);
    if(inputstream)
      fclose(inputstream);
    if(reconfile)
      fclose(reconfile);
    fprintf(stderr,"Cannot open in or output\n");
    exit(1);
  }

  cparams.format = CPARAM_QCIF;

  InitCompress(&cparams);  /* Use standard compression parameters */

  WriteByteFunction = OwnWriteFunction;

  if(!ReadQCIF(inputstream,&qcif_frame)) {
    fprintf(stderr,"Cannot read from inputstream");
    exit(1);
  }

  cparams.inter = CPARAM_INTRA;  
  cparams.Q_intra = 8;
  cparams.data = &qcif_frame;
  fprintf(stderr,"qcif data is on: %p\n",&qcif_frame);
  CompressToH263(&cparams, &bits);
  
  WriteQCIF(reconfile,cparams.recon);

  cparams.inter = CPARAM_INTER;
  cparams.half_pixel_searchwindow = 4;
  cparams.search_method = CPARAM_LOGARITHMIC;
  cparams.Q_inter = 8; 
  cparams.advanced_method = CPARAM_ADVANCED;
  cparams.EncodeThisBlock = &EncodeBlocks;

  while(ReadQCIF(inputstream, &qcif_frame)) {
    ++framecount;

    if(framecount % 4 == 1) {
      /* Only encode one frame out of 4 */
      if(cparams.advanced_method)
	FindMotion(&cparams,2,2);

      CompressToH263(&cparams, &bits);
    }

    /* In case of skipped frames, the previous frame is displayed again,
       therefore, the previous frame should be included in the recon-
       structed QCIF video stream.
    */

    WriteQCIF(reconfile,cparams.recon);

    /* Not really nice, but it's just an example: */

    if(framecount > 150)
      break;
  }
  
  fclose(inputstream);
  fclose(outputstream);
  fclose(reconfile);

  return 0;
}

